/*
 *  Licensed Materials - Property of IBM
 *  IBM Product Name: 5725S57
 *  Copyright IBM Corp. 2011, 2015
 *  US Government Users Restricted Rights - Use, 
 *  duplication or disclosure restricted by GSA 
 *  ADP Schedule Contract with IBM Corp.
 */

/// :nodoc:
typedef NS_ENUM(NSInteger, ASFaspDirection) {
        ASFaspDirectionNone,
        ASFaspDirectionUpload,
        ASFaspDirectionDownload
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASBandwidthMeasurement) {
        ASBandwidthMeasurementNone,
        ASBandwidthMeasurementSend,
        ASBandwidthMeasurementReceive
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASFaspPrecalc) {
        ASFaspPrecalcAny,
        ASFaspPrecalcNo,
        ASFaspPrecalcYes
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASTransferPolicy) {
        ASTransferPolicyAny,
        ASTransferPolicyFixed,
        ASTransferPolicyHigh,
        ASTransferPolicyRegular,
        ASTransferPolicyFair,
        ASTransferPolicyLow,
        ASTransferPolicyTrickle
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASRatePolicy) {
        ASRatePolicyFixed,
        ASRatePolicyFair,
        ASRatePolicyTrickle,
        ASRatePolicyUnset = 0xff
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASRatePriority) {
        ASRatePriorityUnset,
        ASRatePriorityHigh,
        ASRatePriorityRegular
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASResumePolicy) {
        ASResumePolicyNone,
        ASResumePolicyAttrs,
        ASResumePolicySparseCsumOld,
        ASResumePolicyFullCsum,
        ASResumePolicySparseCsum
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASCipher) {
        ASCipherNone,
        ASCipherAES128,
        ASCipherAES192,
        ASCipherAES256
};

/// :nodoc:
typedef NS_OPTIONS(NSInteger, ASCreatePolicy) {
        ASCreatePolicyPreserveTime = 0x01,
        ASCreatePolicyBackup = 0x02,
        ASCreatePolicySkipExisting = 0x04,
        ASCreatePolicyDirPath = 0x08,
        ASCreatePolicyPreserveMode = 0x10,
        ASCreatePolicyPreserveOwnerUID = 0x20,
        ASCreatePolicyPreserveOwnerGID = 0x40
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASOverwritePolicy) {
        ASOverwritePolicyAllow,
        ASOverwritePolicyDeny,
        ASOverwritePolicyNone = 0x00,
        ASOverwritePolicyDiff = 0x01,
        ASOverwritePolicyOlder = 0x02,
        ASOverwritePolicyPrompt = 0x03,
        ASOverwritePolicyNever = 0x3f,
        ASOverwritePolicyAlways = 0xff
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASRateAlgorithm) {
        ASRateAlgorithmNone,
        ASRateAlgorithmDelay,
        ASRateAlgorithmQueue,
        ASRateAlgorithmAlpha,
        ASRateAlgorithmAir
};

/// :nodoc:
typedef NS_OPTIONS(NSInteger, ASXoptFlag) {
        ASXoptFlagSkipSymbolicLinks = 1<<2,
        ASXoptFlagCopySymbolicLinks = 1<<3,
        ASXoptFlagFollowSymbolicLinks = 1<<4,
        ASXoptFlagSkipSpecialFiles = 1<<5,
        ASXoptFlagMayFileEncrypt = 1<<6,
        ASXoptFlagMayFileDecrypt = 1<<7,
        ASXoptFlagNoFileEncrypt = 1<<8,
        ASXoptFlagNoRead = 1<<9,
        ASXoptFlagNoWrite = 1<<10,
        ASXoptFlagChunkedFilePaths = 1<<11
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASFaspEventSession) {
        ASFaspEventSessionInit,
        ASFaspEventSessionStart,
        ASFaspEventSessionStop,
        ASFaspEventFileStart,
        ASFaspEventFileDone,
        ASFaspEventFileStop,
        ASFaspEventFileStat,
        ASFaspEventRateStat,
        ASFaspEventJobStat
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASFaspapiErrorDomain) {
        ASFaspapiErrorDomainFaspapi,
        ASFaspapiErrorDomainLibSSH2,
        ASFaspapiErrorDomainFasp,
        ASFaspapiErrorDomainSockets
};

/// :nodoc:
typedef NS_ENUM(NSInteger, ASDecryptionResult) {
    ASDecryptionResultSuccess = 0x00,
    ASDecryptionResultInternalError = 0x01,
    ASDecryptionResultOpenForWriteFailed = 0x02,
    ASDecryptionResultOpenFailed = 0x03,
    ASDecryptionResultFileCorrupt = 0x04,
    ASDecryptionResultBadPassphrase = 0x05,
};
