//
//  ViewController.swift
//  SdkSampleSwift
//
//  Copyright © 2016 IBM. All rights reserved.
//

import UIKit

class ViewController: UIViewController, ASFaspSessionDelegate {
    @IBOutlet weak var startTransferButton: UIButton!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }


    @IBAction func startTranfserTapped(sender: AnyObject) {
        // Create the session parameters for an upload
        let params = ASFaspSessionParameters.uploadSessionWithHost("demo.asperasoft.com", user: "asperaweb")
        params.password = "demoaspera"
        params.sshPort = 22
        params.destinationPath = "/Upload"
        
        // Create a session with a list of sources
        let fname = NSBundle.mainBundle().pathForResource("10KB", ofType: nil)!
        let session = ASFaspSession(parameters: params, sources: [fname])
        
        // Start the session
        // Note that we could have used startAsyncWithSessionEnd: with a block
        // instead of using a delegate
        session.delegates.addObject(self)
        session.startAsync()
        
        // Disable the transfer button while the session is running
        startTransferButton.enabled = false
    }
    
    
    
    
    
    func sessionDidEnd(session: ASAbstractFaspSession, state finalState: ASFaspSessionState) {
        switch finalState {
        case .Succeeded:
            print("File transferred successfully")
        case .Stopped:
            // The session was stopped by calling session.stop()
            break
        case .Failed:
            print("File transfer failed: \(session.lastError)")
        }
        
        dispatch_async(dispatch_get_main_queue()) {
            self.startTransferButton.enabled = true
        }
    }
}

