//
//  ViewController.swift
//  SdkSampleSwift
//
//  Copyright © 2016 IBM. All rights reserved.
//

import UIKit

class ViewController: UIViewController, ASFaspSessionDelegate {
    @IBOutlet weak var startTransferButton: UIButton!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }


    @IBAction func startTranfserTapped(_ sender: AnyObject) {
        // Create the session parameters for an upload
        let params = ASFaspSessionParameters.uploadSession(withHost: "demo.asperasoft.com", user: "asperaweb")
        params.password = "demoaspera"
        params.sshPort = 22
        params.destinationPath = "/Upload"
        
        // Create a session with a list of sources
        let fname = Bundle.main.path(forResource: "10KB", ofType: nil)!
        let session = ASFaspSession(parameters: params, sources: [fname])
        
        // Start the session
        // Note that we could have used startAsyncWithSessionEnd: with a block
        // instead of using a delegate
        session.delegates.add(self)
        session.startAsync()
        
        // Disable the transfer button while the session is running
        startTransferButton.isEnabled = false
    }
    
    
    
    
    
    func sessionDidEnd(_ session: ASAbstractFaspSession, state finalState: ASFaspSessionState) {
        switch finalState {
        case .succeeded:
            print("File transferred successfully")
        case .stopped:
            // The session was stopped by calling session.stop()
            break
        case .failed:
            print("File transfer failed: \(session.lastError)")
        }

        DispatchQueue.main.async {
            self.startTransferButton.isEnabled = true
        }
    }
}

