//
//  ViewController.m
//  SdkSampleOSX
//
//  Copyright © 2016 IBM. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];
}

- (IBAction)startTransferClicked:(id)sender {
    // Create the session parameters for an upload
    ASFaspSessionParameters *parameters;
    parameters = [ASFaspSessionParameters uploadSessionWithHost:@"127.0.0.1" user:@"aspera"];
    parameters.password = @"aspera";
    parameters.sshPort = 22;
    parameters.destinationPath = @"/";
    
    // Create a session with a list of sources
    NSString *fname = [[NSBundle mainBundle] pathForResource:@"10KB" ofType:@""];
    NSArray *sources = @[fname];
    ASFaspSession *session = [ASFaspSession sessionWithParameters:parameters sources:sources];
    
    // Start the session
    // Note that we could have used startAsyncWithSessionEnd: with a block
    // instead of using a delegate
    [session.delegates addObject:self];
    [session startAsync];
    
    // Disable the transfer button while the session is running
    self.startTransferButton.enabled = NO;
}


- (void)sessionProgressDidChange:(ASAbstractFaspSession *)session {
    NSLog(@"Session progress: %d%% at %.2f bps", (int)(session.stats.progress*100), session.stats.averageBitsPerSecond);
}

- (void)sessionDidEnd:(nonnull ASAbstractFaspSession *)session state:(ASFaspSessionState)finalState {
    if (finalState == ASFaspSessionStateSucceeded) {
        NSLog(@"File transferred successfully");
    }
    else if (finalState == ASFaspSessionStateStopped) {
        // The session was stopped by calling [session stop]
    }
    else if (finalState == ASFaspSessionStateFailed){
        NSLog(@"File transfer failed: %@", session.lastError);
    }
    
    // Re-enable the transfer button
    dispatch_async(dispatch_get_main_queue(), ^{
        self.startTransferButton.enabled = YES;
    });
}

@end
